> For a complete page index, fetch https://developer.close.com/llms.txt # Update a Pipeline PUT https://api.close.com/api/v1/pipeline/{id}/ Content-Type: application/json You can use this endpoint to: * Rename a Pipeline. * Reorder Opportunity Statuses within a Pipeline. * Move an Opportunity Status from a different Pipeline into this one. * To do so, include `{"id": "id_of_the_status_from_another_pipeline"}` in the `statuses` list. Reference: https://developer.close.com/api/resources/pipelines/update ## Authentication - `Authorization` header (basic auth, required) — Use your API key as the username and leave the password empty. - `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer `, where token is your auth token. ## Request ### Path parameters - `id` (string, required) ### Body (application/json) This endpoint expects an UpdatePipeline. - `name` (string, optional, default: ) - `statuses` (list of ExistingPipelineOpportunityStatus, optional, nullable) — Opportunity Statuses of this Pipeline, in the desired order. ## Response ### 200 Successful response - `created_by` (string, required, nullable) - `date_created` (datetime, required) - `date_updated` (datetime, required) - `id` (string, required) - `name` (string, required) - `organization_id` (string, required) - `statuses` (list of PipelineOpportunityStatus, required) - `updated_by` (string, required, nullable) ## Errors ### 400 Bad Request Error Bad request - `any` ### 401 Unauthorized Error Unauthorized - `any` ### 404 Not Found Error Not found - `any` ## Types ### ExistingPipelineOpportunityStatus - `id` (string, required) — ID of an existing Opportunity Status. May belong to a different Pipeline, in which case the status is moved into this one. ### PipelineOpportunityStatus - `id` (string, required) - `label` (string, required) - `type` (enum, required) - Allowed values: `won`, `lost`, `active` ## Examples **Request** ```json { "name": "Updated Name", "statuses": [ { "id": "stat_3mmBOyMmaG8yc4DmAPp9WmgbjhVctVLlnd9gmvWxBe2" }, { "id": "stat_IOCtLYbAclJ8XAcb3yLUhQA3zlmjtXz8JMBLyXnNMF8" }, { "id": "stat_3PB2sedHBCjwuBImAEwgHOo858f2j41lpROkcl51Fzp" } ] } ``` **Response** ```json { "created_by": "user_N6KhMpzHRCYQHdn4gRNIFNN5JExnsrprKA6ekxM63XA", "date_created": "2019-11-04T11:04:13.014979", "date_updated": "2019-11-15T14:12:13.051542", "id": "pipe_6gV01if4wo7r2YTVQDWP2j", "name": "Updated Name", "organization_id": "orga_RbREgmiiwcr1w2b4cOnCMQaQPSIFxMqAD2Dh243uxcH", "statuses": [ { "id": "stat_3mmBOyMmaG8yc4DmAPp9WmgbjhVctVLlnd9gmvWxBe2", "label": "Lost", "type": "lost" }, { "id": "stat_IOCtLYbAclJ8XAcb3yLUhQA3zlmjtXz8JMBLyXnNMF8", "label": "Won", "type": "won" }, { "id": "stat_3PB2sedHBCjwuBImAEwgHOo858f2j41lpROkcl51Fzp", "label": "Active", "type": "active" } ], "updated_by": "user_N6KhMpzHRCYQHdn4gRNIFNN5JExnsrprKA6ekxM63XA" } ``` **SDK Code** ```python pipelines_update_example import requests url = "https://api.close.com/api/v1/pipeline/id/" payload = { "name": "Updated Name", "statuses": [{ "id": "stat_3mmBOyMmaG8yc4DmAPp9WmgbjhVctVLlnd9gmvWxBe2" }, { "id": "stat_IOCtLYbAclJ8XAcb3yLUhQA3zlmjtXz8JMBLyXnNMF8" }, { "id": "stat_3PB2sedHBCjwuBImAEwgHOo858f2j41lpROkcl51Fzp" }] } headers = { "Content-Type": "application/json" } response = requests.put(url, json=payload, headers=headers, auth=("", "")) print(response.json()) ``` ```javascript pipelines_update_example const url = 'https://api.close.com/api/v1/pipeline/id/'; const credentials = btoa(":"); const options = { method: 'PUT', headers: {Authorization: `Basic ${credentials}`, 'Content-Type': 'application/json'}, body: '{"name":"Updated Name","statuses":[{"id":"stat_3mmBOyMmaG8yc4DmAPp9WmgbjhVctVLlnd9gmvWxBe2"},{"id":"stat_IOCtLYbAclJ8XAcb3yLUhQA3zlmjtXz8JMBLyXnNMF8"},{"id":"stat_3PB2sedHBCjwuBImAEwgHOo858f2j41lpROkcl51Fzp"}]}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go pipelines_update_example package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.close.com/api/v1/pipeline/id/" payload := strings.NewReader("{\n \"name\": \"Updated Name\",\n \"statuses\": [\n {\n \"id\": \"stat_3mmBOyMmaG8yc4DmAPp9WmgbjhVctVLlnd9gmvWxBe2\"\n },\n {\n \"id\": \"stat_IOCtLYbAclJ8XAcb3yLUhQA3zlmjtXz8JMBLyXnNMF8\"\n },\n {\n \"id\": \"stat_3PB2sedHBCjwuBImAEwgHOo858f2j41lpROkcl51Fzp\"\n }\n ]\n}") req, _ := http.NewRequest("PUT", url, payload) req.SetBasicAuth("", "") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby pipelines_update_example require 'uri' require 'net/http' url = URI("https://api.close.com/api/v1/pipeline/id/") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Put.new(url) request.basic_auth("", "") request["Content-Type"] = 'application/json' request.body = "{\n \"name\": \"Updated Name\",\n \"statuses\": [\n {\n \"id\": \"stat_3mmBOyMmaG8yc4DmAPp9WmgbjhVctVLlnd9gmvWxBe2\"\n },\n {\n \"id\": \"stat_IOCtLYbAclJ8XAcb3yLUhQA3zlmjtXz8JMBLyXnNMF8\"\n },\n {\n \"id\": \"stat_3PB2sedHBCjwuBImAEwgHOo858f2j41lpROkcl51Fzp\"\n }\n ]\n}" response = http.request(request) puts response.read_body ``` ```java pipelines_update_example import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.put("https://api.close.com/api/v1/pipeline/id/") .basicAuth("", "") .header("Content-Type", "application/json") .body("{\n \"name\": \"Updated Name\",\n \"statuses\": [\n {\n \"id\": \"stat_3mmBOyMmaG8yc4DmAPp9WmgbjhVctVLlnd9gmvWxBe2\"\n },\n {\n \"id\": \"stat_IOCtLYbAclJ8XAcb3yLUhQA3zlmjtXz8JMBLyXnNMF8\"\n },\n {\n \"id\": \"stat_3PB2sedHBCjwuBImAEwgHOo858f2j41lpROkcl51Fzp\"\n }\n ]\n}") .asString(); ``` ```php pipelines_update_example request('PUT', 'https://api.close.com/api/v1/pipeline/id/', [ 'body' => '{ "name": "Updated Name", "statuses": [ { "id": "stat_3mmBOyMmaG8yc4DmAPp9WmgbjhVctVLlnd9gmvWxBe2" }, { "id": "stat_IOCtLYbAclJ8XAcb3yLUhQA3zlmjtXz8JMBLyXnNMF8" }, { "id": "stat_3PB2sedHBCjwuBImAEwgHOo858f2j41lpROkcl51Fzp" } ] }', 'headers' => [ 'Content-Type' => 'application/json', ], 'auth' => ['', ''], ]); echo $response->getBody(); ``` ```csharp pipelines_update_example using RestSharp; using RestSharp.Authenticators; var client = new RestClient("https://api.close.com/api/v1/pipeline/id/"); client.Authenticator = new HttpBasicAuthenticator("", ""); var request = new RestRequest(Method.PUT); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"name\": \"Updated Name\",\n \"statuses\": [\n {\n \"id\": \"stat_3mmBOyMmaG8yc4DmAPp9WmgbjhVctVLlnd9gmvWxBe2\"\n },\n {\n \"id\": \"stat_IOCtLYbAclJ8XAcb3yLUhQA3zlmjtXz8JMBLyXnNMF8\"\n },\n {\n \"id\": \"stat_3PB2sedHBCjwuBImAEwgHOo858f2j41lpROkcl51Fzp\"\n }\n ]\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ```